// Cagent.cpp

// Declaration of the Agent Class Functions
// Walter Schuller
// University of North Florida
// 
// Switch Agent Program
//
// Agent SNMP Class Virtual Functions Defined
// 
// Last updated May 96
//
//           
		
                                                                      
//*************************************************************************

#include "general.hpp"
#include "calls.hpp"

//*************************************************************************


CSnmpAgent::CSnmpAgent(HINSTANCE hinst, HWND hwnd) :
      CPowerSnmp(hinst), hwndMain(hwnd)
   {
   
   }
   

//*************************************************************************
// A UDP port has been successfully allocated.

void CSnmpAgent::ConnectSnmpEvent(LPCSTR lpszLocalDotAddr, WORD wLocalPort, 
      LPCSTR lpszLocalName, WORD wMaxByteCnt)
   {
   char szStatus[128];
   
   _fstrcpy(szLocalDotAddr, lpszLocalDotAddr);
   wsprintf(szStatus, "Listening on port %d.  MaxPacketSize = %d",
         wLocalPort, wMaxByteCnt);
  
   SetDlgItemText(hwndMain, IDC_STATUS, szStatus);   
   }
 
   
//*************************************************************************
// Process Received SNMP Messages.

void CSnmpAgent::RecvSnmpEvent(LPCSTR lpszCommunity, DWORD dwRequestId, 
      SNMP_ERROR codeSnmpError, int nErrorIndex, SNMP_TYPE MessageType, 
      UINT nObjects, LPSTR FAR* lpObjectId, LONG FAR* lpObjectValue, 
      SNMP_OBJECT_TYPE FAR* lpObjectType, LPCSTR lpszRemoteDotAddr,
      WORD wRemotePort)
   {
   SNMP_OBJECT_TYPE fObjectType = SNMP_OCTET_STRING;
   
   UINT i;
   HINSTANCE hinst = GetWindowInstance(hwndMain);
   
   Ccontrol 	ctl;
   
     
   codeSnmpError = SNMP_NO_ERROR;

//-----------------------------------------------------------------------
// SNMP GET REQUEST Type Message

   switch (MessageType)
      {

      case SNMP_GET_REQUEST:  

         lpObjectValue = (LONG FAR*) GlobalAllocPtr(GPTR, nObjects * sizeof(LONG));  
         lpObjectType = (SNMP_OBJECT_TYPE FAR*) 
               GlobalAllocPtr(GPTR, nObjects * sizeof(SNMP_OBJECT_TYPE FAR*));
         
         for(i=0; i < nObjects; ++i) {};
 
         SendGetResponse(lpszRemoteDotAddr, wRemotePort, lpszCommunity, 
               dwRequestId, codeSnmpError, nErrorIndex, nObjects, 
               lpObjectId, lpObjectValue, lpObjectType);
         
         GlobalFreePtr(lpObjectValue);
         GlobalFreePtr(lpObjectType);
         break; 

//---------------------------------------------------------------------
//  SNMP SET REQUEST Type Message
      
       case SNMP_SET_REQUEST:
         
         for (i = 0; i < nObjects; ++i)
            {
            if (IsEqual(hinst, IDS_Switch1, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 1");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 1");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch1();
           		}

            else if (IsEqual(hinst, IDS_Switch2, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 2");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 2");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch2();
            	}

            else if (IsEqual(hinst, IDS_Switch3, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 3");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 3");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch3();
            	}

            else if (IsEqual(hinst, IDS_Switch4, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 4");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 4");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch4();
            	}

            else if (IsEqual(hinst, IDS_Switch5, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 5");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 5");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch5();
            	}

            else if (IsEqual(hinst, IDS_Switch6, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 6");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 6");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch6();
            	}

            else if (IsEqual(hinst, IDS_Switch7, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 7");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 7");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch7();
            	}

            else if (IsEqual(hinst, IDS_Switch8, lpObjectId[i])) 
            	{
  			   	SetDlgItemText(hwndMain, IDC_CMDEXECUTED, "TRIGGER SWITCH 8");
   			   	SetDlgItemText(hwndMain, IDC_CMDRECEIVED, "SET SWITCH 8");
               	SetDlgItemText(hwndMain, IDC_CMDRESPONSE, "COMPLETE");

				ctl.Switch8();
            	}

            }
            
            
         SendGetResponse(lpszRemoteDotAddr, wRemotePort, lpszCommunity, 
               dwRequestId, SNMP_NO_ERROR, 0, nObjects, lpObjectId, 
               lpObjectValue, lpObjectType);
         break; 
         
      }
      
   }
   
   
//*************************************************************************
// Display Error Message

void CSnmpAgent::ExceptionEvent(PT_EXCEPTION codeError, 
      LPCSTR lpszErrorDesc)    
   {                                               
   SetDlgItemText(hwndMain, IDC_STATUS, lpszErrorDesc);   
   }
   

//*************************************************************************
//  END OF FILE                              WALT SCHULLER
