// Ccontrol.cpp
//
// Class made from the MarshallSoft toolkit
// 
// Switch Agent Program
//
// Control Class Functions Defined
// 
// Last updated May 96
//
// Walter Schuller
// University of North Florida
//  


#include "general.hpp"
#include "calls.hpp"
 
// Sony Tape Control Command Strings

 int switch1[]         =  {4,0x55,0x00,0x00,0x01};
 int switch2[]         =  {4,0x55,0x00,0x00,0x02};
 int switch3[]         =  {4,0x55,0x00,0x00,0x04};
 int switch4[]         =  {4,0x55,0x00,0x00,0x08};
 int switch5[]         =  {4,0x55,0x00,0x00,0x10};
 int switch6[]         =  {4,0x55,0x00,0x00,0x20};
 int switch7[]         =  {4,0x55,0x00,0x00,0x40};
 int switch8[]         =  {4,0x55,0x00,0x00,0x80};
 
//*****************************************************************
// Constructor

Ccontrol::Ccontrol(int v, int w, int x, int y, int z)
	{ 
	Port=v;
	BaudCode=w;
	Parity=x;
	StopBits=y;
	DataBits=z;
	             
	SioParms(Port, Parity, StopBits, DataBits);
	SioReset(Port, 128, 128);               
	SioBaud(Port,BaudCode);  
	
	}
	


//*****************************************************************
// Destructor

Ccontrol::~Ccontrol()
	{
	SioDone(Port); 
	MessageBeep(-10);
	}
	

//*****************************************************************
// Part of Send Command

 int Ccontrol::send_cmd(int *cmdptr)
 {
	 int i=0, num, count = 0;
	 num = *cmdptr;
	 for (count=1;count<num+1;count++)
		{
		SioPutc(Port,*(cmdptr + count));
		delay(0.5);
		}
	
	 return 0;
 }


//*****************************************************************
// Set Switch1 Command

void Ccontrol::Switch1()
	{
	send_cmd(switch1);
	}

	
//*****************************************************************

// Set Switch2 Command

void Ccontrol::Switch2()
	{
	send_cmd(switch2);
	}

	
//*****************************************************************
// Set Switch3 Command

void Ccontrol::Switch3()
	{
	send_cmd(switch3);
	}

	
//*****************************************************************
// Set Switch4 Command

void Ccontrol::Switch4()
	{
	send_cmd(switch4);
	}

	
//*****************************************************************
// Set Switch5 Command

void Ccontrol::Switch5()
	{
	send_cmd(switch5);
	}

	
//*****************************************************************
// Set Switch6 Command

void Ccontrol::Switch6()
	{
	send_cmd(switch6);
	}

	
//*****************************************************************
// Set Switch7 Command

void Ccontrol::Switch7()
	{
	send_cmd(switch7);
	}

	
//*****************************************************************
// Set Switch8 Command

void Ccontrol::Switch8()
	{
	send_cmd(switch8);
	}

	

//*****************************************************************
// END OF FILE                        WALT SCHULLER
