// CLASSES.H
// 
// Walter Schuller
// University of North Florida
//  
// Last updated May 97
//
// Manager SNMP Class Virtual Functions Defined
//


#ifndef CLASSES_H
#define CLASSES_H  

#include "\Powertcp\include\common.h"
#include "\Powertcp\include\powersnm.hpp"
#include "snmpm.hh" 



// SNMP Class

class CSnmpManager : public CPowerSnmp
{
public:
   
   CSnmpManager(HINSTANCE hinst, HWND hwnd);

   HWND        hwndMain;            // identifies the main window    
   HWND        hwndAddrTran;        // address translation table
   int         nAttList;            // current list in our AT table
   int         state;               // type of query being made
   char        szRemoteHost[64];    // name of remote host
   char        szLastObjectId[64];  // last object id queired

protected:

   void ConnectSnmpEvent(LPCSTR lpszLocalDotAddr, WORD wLocalPort, 
         LPCSTR lpszLocalName, WORD wMaxByteCnt);

   void RecvSnmpEvent(LPCSTR lpszCommunity, DWORD dwRequestId, 
         SNMP_ERROR codeSnmpError, int nErrorIndex, SNMP_TYPE MessageType, 
         UINT nObjects, LPSTR FAR* lpszObjectId, LONG FAR* lpObjectValue, 
         SNMP_OBJECT_TYPE FAR* lpObjectType, LPCSTR lpszRemoteDotAddr,
         WORD wRemotePort);

   void ExceptionEvent(PT_EXCEPTION codeError, LPCSTR lpszErrorDesc);
};

 

#endif

//****************************************************************
//  END OF FILE                            WALT SCHULLER
