// CLASSES.HPP
// 
// Walter Schuller
// University of North Florida
//  
// Last updated March 97
//
// Classes defined for the Transmitter Control Agent program.....
//



#ifndef CLASSES_H
#define CLASSES_H  

#include "\Powertcp\include\common.h"
#include "\Powertcp\include\powersnm.hpp"
#include "snmpa.hh" 
#include "message.h"
#include "wsc.h"
#include "ascii.h" 


//***************************************************************
//  SNMP Agent Class


class CSnmpAgent : public CPowerSnmp
{
public:
   
   CSnmpAgent(HINSTANCE hinst, HWND hwnd);

   HWND        hwndMain;           
   

   char         szLocalDotAddr[64];
   char         szSysDescr[64];
   char         szSysObjectId[32];
   char         szSysContact[64];
   char         szSysName[64];
   char         szSysLocation[64];

protected:

   void ConnectSnmpEvent(LPCSTR lpszLocalDotAddr, WORD wLocalPort, 
         LPCSTR lpszLocalName, WORD wMaxByteCnt);

   void RecvSnmpEvent(LPCSTR lpszCommunity, DWORD dwRequestId, 
         SNMP_ERROR codeSnmpError, int nErrorIndex, SNMP_TYPE MessageType, 
         UINT nObjects, LPSTR FAR* lpszObjectId, LONG FAR* lpObjectValue, 
         SNMP_OBJECT_TYPE FAR* lpObjectType, LPCSTR lpszRemoteDotAddr,
         WORD wRemotePort);

   void ExceptionEvent(PT_EXCEPTION codeError, LPCSTR lpszErrorDesc);
};

 
// ****************************************************************
// Ccontrol Class 
// Class made from the MarshallSoft toolkit

	class	Ccontrol
		{
		
		public:        
            char RxBuf[128];
		
		public:
			Ccontrol(int = COM1, int = Baud38400, int = OddParity,
					 int = OneStopBit, int = WordLength8);
			
			~Ccontrol();
			
			void Sony_play(); 
			void Sony_stop();
			void Sony_rewind();
			void Sony_forward();
			void Sony_eject();
			void Sony_record();
			void Sony_time();
			
		private:
			int Port;
			int BaudCode;
			int Parity;
			int StopBits;
			int DataBits;
		    
			char time_buffer[100];
			
            int send_cmd(int *cmdptr);
                        
       };
       

#endif

//***************************************************************
//  END OF FILE                             WALT SCHULLER
