// Cmanager.cpp
//
// Declaration of the Management Class Functions
// Walter Schuller
// University of North Florida
//  
// Last Update March 97
// 
// SNMP MANAGER PROGRAM FOR TRANSMITTER CONTROL

//*************************************************************************

#include "general.hpp"
#include "calls.hpp"

//*************************************************************************
    

CSnmpManager::CSnmpManager(HINSTANCE hinst, HWND hwnd) :
      CPowerSnmp(hinst), hwndMain(hwnd)
   {
   
   }
   

//*************************************************************************
// A UDP Port has been Successfully Allocated

void CSnmpManager::ConnectSnmpEvent(LPCSTR lpszLocalDotAddr, WORD wLocalPort, 
      LPCSTR lpszLocalName, WORD wMaxByteCnt)
   { 
   SetDlgItemText(hwndMain, IDC_STAT, " UDP Port Opened");
   }
   
   
//*************************************************************************
// Process SNMP Messages Received 


void CSnmpManager::RecvSnmpEvent(LPCSTR lpszCommunity, DWORD dwRequestId, 
      SNMP_ERROR codeSnmpError, int nErrorIndex, SNMP_TYPE MessageType, 
      UINT nObjects, LPSTR FAR* lpszObjectId, LONG FAR* lpObjectValue, 
      SNMP_OBJECT_TYPE FAR* lpObjectType, LPCSTR lpszRemoteDotAddr,
      WORD wRemotePort)
   {
   char szBuffer[64];
   
   switch (state)
      {
      case SNMPM_STATE_BROADCAST:
         
         ListBox_AddString(GetDlgItem(hwndMain, 
               IDC_HOSTLIST), lpszRemoteDotAddr);
      break;

      case SNMPM_STATE_QUERYHOST:
         {

         HINSTANCE hinst;
         UINT i;             
                            
         hinst = GetWindowInstance(hwndMain);
                            
         for (i = 0; i < nObjects; ++i)
            {
            if (0 == _fstrcmp(GetString(hinst, IDS_TxVisPwr),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_VISUAL_PWR, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        
 
            else if (0 == _fstrcmp(GetString(hinst, IDS_TxAurPwr),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_AURAL_PWR, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        

            else if (0 == _fstrcmp(GetString(hinst, IDS_TxAPlateKV),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_A_KV, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        
 
            else if (0 == _fstrcmp(GetString(hinst, IDS_TxBPlateKV),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_B_KV, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        

            else if (0 == _fstrcmp(GetString(hinst, IDS_TxAPlateAmp),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_A_AMP, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        
 
            else if (0 == _fstrcmp(GetString(hinst, IDS_TxBPlateAmp),
                  lpszObjectId[i]))                     
               SetDlgItemText(hwndMain, 
                     IDC_B_AMP, (LPSTR) ltoa(lpObjectValue[i],
                     szBuffer,10));                        
 
            }
                   
         break;
         }
         
               
      default:
         break;    
      }
   }
   
   
//*************************************************************************
// Display Error

void CSnmpManager::ExceptionEvent(PT_EXCEPTION codeError, 
      LPCSTR lpszErrorDesc)
   {
   SetDlgItemText(hwndMain, IDC_STAT, lpszErrorDesc);   
   }
   

//*************************************************************************
// END OF FILE                              WALT SCHULLER
 